/************************************************************************/
/*  TP GPU - GLSL Ensimag 3A                                            */
/*  Sbastien Barbier - EVASION                                         */
/*	janvier 2009														*/
/************************************************************************/

#include "headers.h"
#include <fstream>
#include <iostream>
#include <sstream>

using namespace std;

/**************************************
              SHADERS
***************************************/

inline char* getStringFromFile( const char* filename)
{
    
    string data = "";
	ifstream mfile(filename);
    
    if (!mfile)
        data = "erreur";
    else
    {
        stringstream buffer;
        buffer << mfile.rdbuf();
        mfile.close();
	data = buffer.str();
    }
 
    char* buff = new char[data.size()];
    sprintf(buff,data.c_str());

    return buff;
}

void initShadersGeo(GLhandleARB *program_shader_passe, char *s_name)
{
	//cout << "*************************************" << endl
	//	 << "Compiling shaders" << endl;

	GLhandleARB vertex_shader_passe   = glCreateShaderObjectARB(GL_VERTEX_SHADER_ARB);
	GLhandleARB fragment_shader_passe = glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);
	GLhandleARB geometry_shader_passe = glCreateShaderObjectARB(GL_GEOMETRY_SHADER_EXT);
	           *program_shader_passe  = glCreateProgramObjectARB();

	//cout << "created objects and program" << endl;

	string shader_name_passe = s_name;
	string filenamev = shader_name_passe + ".vert";
	string filenameg = shader_name_passe + ".geo";
	string filenamef = shader_name_passe + ".frag";

	char  *vshader_name = getStringFromFile(filenamev.c_str());
	/*cout << "*********************************" << endl
		 << "VERTEX SHADER :"          << endl
		 << vshader_name << endl               << endl;
	cout << "*********************************" << endl;*/

	char  *gshader_name = getStringFromFile(filenameg.c_str());
	/*cout << "*********************************" << endl
		 << "GEOMETRY SHADER :"          << endl
		 << gshader_name << endl               << endl;
	cout << "*********************************" << endl;*/
	
	char  *fshader_name = getStringFromFile(filenamef.c_str());
	/*cout << "*********************************" << endl
		 << "FRAGMENT SHADER :"          << endl
		 << fshader_name << endl               << endl;
	cout << "*********************************" << endl;*/


	const char* vfs = vshader_name;
	const char* gfs = gshader_name;
	const char* pfs = fshader_name;
	
	glShaderSourceARB(vertex_shader_passe, 1, &vfs, NULL);
	glShaderSourceARB(geometry_shader_passe, 1, &gfs, NULL);
	glShaderSourceARB(fragment_shader_passe, 1, &pfs, NULL);
	//cout << "source linked" << endl;

	glCompileShaderARB(vertex_shader_passe);
	glCompileShaderARB(geometry_shader_passe);
	glCompileShaderARB(fragment_shader_passe);
	//cout << "compiled objects" << endl;

	glAttachObjectARB(*program_shader_passe,vertex_shader_passe);
	glAttachObjectARB(*program_shader_passe,geometry_shader_passe);
	glAttachObjectARB(*program_shader_passe,fragment_shader_passe);
	//cout << "objects attached to program" << endl;

	//Paramtres du geometry shader
	glProgramParameteriEXT(*program_shader_passe, GL_GEOMETRY_INPUT_TYPE_EXT, GL_TRIANGLES_ADJACENCY_EXT);
	glProgramParameteriEXT(*program_shader_passe, GL_GEOMETRY_OUTPUT_TYPE_EXT, GL_LINE_STRIP);
	int nb_max_vertex = 6;
	glProgramParameteriEXT(*program_shader_passe, GL_GEOMETRY_VERTICES_OUT_EXT, nb_max_vertex);
	
	glLinkProgramARB(*program_shader_passe);
	//cout << "program linked" << endl;
	//cout << "Compiling shaders" << endl
	//	 << "*************************************" << endl;

	GLcharARB *infoLog;

	infoLog = (GLcharARB*) malloc(5000*sizeof(GLcharARB));
	
	cout << "*************************************" << endl
		 << "Compiling shader " << s_name << endl;

	glUseProgramObjectARB(*program_shader_passe);

	glGetInfoLogARB(*program_shader_passe, 5000, NULL, infoLog);

	cout << "Errors:" << endl << infoLog << endl;
    
	cout << "*************************************" << endl;
	
	//cout << "Using shader passe 1" << endl
	//	 << "*************************************" << endl;

    glUseProgramObjectARB(0);

}

void initShadersGeoWithoutFile(GLhandleARB *program_shader_passe, const char *vert, const char *frag)
{
	//cout << "*************************************" << endl
	//	 << "Compiling shaders" << endl;

	GLhandleARB vertex_shader_passe   = glCreateShaderObjectARB(GL_VERTEX_SHADER_ARB);
	GLhandleARB fragment_shader_passe = glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);
	           *program_shader_passe  = glCreateProgramObjectARB();

	//cout << "created objects and program" << endl;
			
	char  *vshader_name = getStringFromFile(vert);
	//cout << "*********************************" << endl
	//	 << "FRAGMENT SHADER PASSE 1:"          << endl
	//	 << vshader_name << endl               << endl;
	//cout << "*********************************" << endl;
	
	char  *fshader_name = getStringFromFile(frag);
	//cout << "*********************************" << endl
	//	 << "FRAGMENT SHADER PASSE 1:"          << endl
	//	 << fshader_name << endl               << endl;
	//cout << "*********************************" << endl;
			
	const char* vfs = vshader_name;
	const char* pfs = fshader_name;

	glShaderSourceARB(vertex_shader_passe, 1, &vfs, NULL);
	glShaderSourceARB(fragment_shader_passe, 1, &pfs, NULL);
	//cout << "source linked" << endl;

	glCompileShaderARB(vertex_shader_passe);
	glCompileShaderARB(fragment_shader_passe);
	//cout << "compiled objects" << endl;

	glAttachObjectARB(*program_shader_passe,vertex_shader_passe);
	glAttachObjectARB(*program_shader_passe,fragment_shader_passe);
	//cout << "objects attached to program" << endl;
	
	glLinkProgramARB(*program_shader_passe);
	//cout << "program linked" << endl;
	//cout << "Compiling shaders" << endl
	//	 << "*************************************" << endl;

	GLcharARB *infoLog;

	infoLog = (GLcharARB*) malloc(5000*sizeof(GLcharARB));
	
	cout << "*************************************" << endl
		 << "Compiling shader " << vert << endl;

	glUseProgramObjectARB(*program_shader_passe);

	glGetInfoLogARB(*program_shader_passe, 5000, NULL, infoLog);

	cout << "Errors:" << endl << infoLog << endl;
    
	cout << "*************************************" << endl;
	
	//cout << "Using shader passe 1" << endl
	//	 << "*************************************" << endl;

    glUseProgramObjectARB(0);

}